# Copyright (c) 2017-present, Facebook, Inc. All rights reserved.
#
# You are hereby granted a non-exclusive, worldwide, royalty-free license to use,
# copy, modify, and distribute this software in source code or binary form for use
# in connection with the web services and APIs provided by Facebook.
#
# As with any software that integrates with the Facebook platform, your use of
# this software is subject to the Facebook Platform Policy
# [http://developers.facebook.com/policy/]. This copyright notice shall be
# included in all copies or substantial portions of the software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
# FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
# COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
# IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
# CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

# FB:AUTOGEN

module FacebookAds
  # This class is auto-generated.

  # For any issues or feature requests related to this class, please let us know
  # on github and we'll fix in our codegen framework. We'll not be able to accept
  # pull request for this class.

  class AdAccountDefaultObjective < AdObject
    DEFAULT_OBJECTIVE_FOR_USER = [
      "APP_INSTALLS",
      "BRAND_AWARENESS",
      "CANVAS_APP_ENGAGEMENT",
      "CANVAS_APP_INSTALLS",
      "EVENT_RESPONSES",
      "LEAD_GENERATION",
      "LINK_CLICKS",
      "LOCAL_AWARENESS",
      "MESSAGES",
      "MOBILE_APP_ENGAGEMENT",
      "MOBILE_APP_INSTALLS",
      "NONE",
      "OFFER_CLAIMS",
      "PAGE_LIKES",
      "POST_ENGAGEMENT",
      "PRODUCT_CATALOG_SALES",
      "VIDEO_VIEWS",
      "WEBSITE_CONVERSIONS",
    ]

    OBJECTIVE_FOR_LEVEL = [
      "APP_INSTALLS",
      "BRAND_AWARENESS",
      "CANVAS_APP_ENGAGEMENT",
      "CANVAS_APP_INSTALLS",
      "EVENT_RESPONSES",
      "LEAD_GENERATION",
      "LINK_CLICKS",
      "LOCAL_AWARENESS",
      "MESSAGES",
      "MOBILE_APP_ENGAGEMENT",
      "MOBILE_APP_INSTALLS",
      "NONE",
      "OFFER_CLAIMS",
      "PAGE_LIKES",
      "POST_ENGAGEMENT",
      "PRODUCT_CATALOG_SALES",
      "VIDEO_VIEWS",
      "WEBSITE_CONVERSIONS",
    ]


    field :default_objective_for_user, { enum: -> { DEFAULT_OBJECTIVE_FOR_USER }}
    field :objective_for_level, { enum: -> { OBJECTIVE_FOR_LEVEL }}
    has_no_id
    has_no_get
    has_no_post
    has_no_delete

  end
end
